diff --git a/src/main/java/net/minecraft/client/gui/GuiConnectFailed.java b/src/main/java/net/minecraft/client/gui/ConnectFailedScreen.java
similarity index 63%
rename from src/main/java/net/minecraft/client/gui/GuiConnectFailed.java
rename to src/main/java/net/minecraft/client/gui/ConnectFailedScreen.java
index 94d6f7c1b..31b388655 100644
--- a/src/main/java/net/minecraft/client/gui/GuiConnectFailed.java
+++ b/src/main/java/net/minecraft/client/gui/ConnectFailedScreen.java
@@ -7,10 +7,10 @@ import net.minecraft.client.Minecraft;
 
 import net.minecraft.core.lang.I18n;
 
-public class GuiConnectFailed extends GuiScreen
+public class ConnectFailedScreen extends Screen
 {
 
-	public GuiConnectFailed(String s, String s1, Object aobj[]) {
+	public ConnectFailedScreen(String s, String s1, Object aobj[]) {
 		I18n stringtranslate = I18n.getInstance();
 		this.errorMessage = stringtranslate.translateKey(s);
 		
@@ -35,7 +35,7 @@ public class GuiConnectFailed extends GuiScreen
     }
 
     @Override
-	public void keyTyped(char c, int i, int mouseX, int mouseY)
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
     }
 
@@ -43,26 +43,26 @@ public class GuiConnectFailed extends GuiScreen
 	public void init()
     {
         I18n stringtranslate = I18n.getInstance();
-        controlList.clear();
-        controlList.add(new GuiButton(0, width / 2 - 100, height / 4 + 120 + 12, stringtranslate.translateKey("gui.connect_failed.button.back")));
+        buttons.clear();
+        buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 120 + 12, stringtranslate.translateKey("gui.connect_failed.button.back")));
     }
 
     @Override
-	protected void buttonPressed(GuiButton button)
+	protected void buttonClicked(ButtonElement button)
     {
         if(button.id == 0)
         {
-            mc.displayGuiScreen(new GuiMainMenu());
+            mc.displayScreen(new MainMenuScreen());
         }
     }
 
     @Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick)
+	public void render(int xm, int ym, float partialTick)
     {
-        drawDefaultBackground();
-        drawStringCentered(fontRenderer, errorMessage, width / 2, height / 2 - 50, 0xffffff);
-        drawStringCentered(fontRenderer, errorDetail, width / 2, height / 2 - 10, 0xffffff);
-        super.drawScreen(mouseX, mouseY, partialTick);
+        renderBackground();
+        drawStringCentered(font, errorMessage, width / 2, height / 2 - 50, 0xffffff);
+        drawStringCentered(font, errorDetail, width / 2, height / 2 - 10, 0xffffff);
+        super.render(xm, ym, partialTick);
     }
 
     private String errorMessage;
diff --git a/src/main/java/net/minecraft/client/gui/ConnectToIpScreen.java b/src/main/java/net/minecraft/client/gui/ConnectToIpScreen.java
new file mode 100644
index 000000000..88b74b202
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/ConnectToIpScreen.java
@@ -0,0 +1,98 @@
+package net.minecraft.client.gui;
+
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.ServerAddress;
+import org.lwjgl.input.Keyboard;
+
+// Referenced classes of package net.minecraft.src:
+//            GuiScreen, GuiTextField, StringTranslate, GuiButton, 
+//            gGameSettings, GuiConnecting
+
+public class ConnectToIpScreen extends Screen
+{
+
+    public ConnectToIpScreen(Screen parent)
+    {
+        super(parent);
+    }
+
+    @Override
+	public void tick()
+    {
+        textField.updateCursorCounter();
+    }
+
+    @Override
+	public void init()
+    {
+        I18n stringtranslate = I18n.getInstance();
+        Keyboard.enableRepeatEvents(true);
+        buttons.clear();
+        buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 96 + 12, stringtranslate.translateKey("gui.connect_to_ip.button.connect")));
+        buttons.add(new ButtonElement(1, width / 2 - 100, height / 4 + 120 + 12, stringtranslate.translateKey("gui.connect_to_ip.button.cancel")));
+        String s = mc.gameSettings.lastServer.value.replaceAll("_", ":");
+        buttons.get(0).enabled = s.length() > 0;
+        textField = new TextFieldElement(this, font, width / 2 - 100, (height / 4 - 10) + 50 + 18, 200, 20, s, "");
+        textField.isFocused = true;
+        textField.setMaxStringLength(128);
+    }
+
+    @Override
+	public void removed()
+    {
+        Keyboard.enableRepeatEvents(false);
+    }
+
+    @Override
+	protected void buttonClicked(ButtonElement button)
+    {
+        if(!button.enabled)
+        {
+            return;
+        }
+        if(button.id == 1)
+        {
+            mc.displayScreen(parentScreen);
+        } else
+        if(button.id == 0)
+        {
+            String serverUrl = textField.getText().trim();
+            mc.gameSettings.lastServer.value = serverUrl.replaceAll(":", "_");
+            mc.gameSettings.saveOptions();
+            ServerAddress address = ServerAddress.resolveServerIP(serverUrl);
+            mc.displayScreen(new ConnectingScreen(mc, address.getIP(), address.getPort()));
+        }
+    }
+
+    @Override
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
+    {
+        if(eventKey != Keyboard.KEY_BACK) super.keyPressed(eventCharacter, eventKey, mx, my);
+        textField.textboxKeyTyped(eventCharacter, eventKey);
+        if(eventCharacter == '\r')
+        {
+            buttonClicked((ButtonElement) buttons.get(0));
+        }
+        ((ButtonElement) buttons.get(0)).enabled = textField.getText().length() > 0;
+    }
+
+    @Override
+	public void mouseClicked(int mx, int my, int buttonNum)
+    {
+        super.mouseClicked(mx, my, buttonNum);
+        textField.mouseClicked(mx, my, buttonNum);
+    }
+
+    @Override
+	public void render(int xm, int ym, float partialTick)
+    {
+        I18n i18n = I18n.getInstance();
+        renderBackground();
+        drawStringCentered(font, i18n.translateKey("gui.connect_to_ip.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
+        drawString(font, i18n.translateKey("gui.connect_to_ip.label.enter_ip"), width / 2 - 140, (height / 4 - 60) + 60 + 36, 0xa0a0a0);
+        textField.drawTextBox();
+        super.render(xm, ym, partialTick);
+    }
+
+    private TextFieldElement textField;
+}
diff --git a/src/main/java/net/minecraft/client/gui/GuiConnecting.java b/src/main/java/net/minecraft/client/gui/ConnectingScreen.java
similarity index 63%
rename from src/main/java/net/minecraft/client/gui/GuiConnecting.java
rename to src/main/java/net/minecraft/client/gui/ConnectingScreen.java
index 1a5263144..b0752f6dd 100644
--- a/src/main/java/net/minecraft/client/gui/GuiConnecting.java
+++ b/src/main/java/net/minecraft/client/gui/ConnectingScreen.java
@@ -1,9 +1,11 @@
 package net.minecraft.client.gui;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.net.handler.ClientPacketHandler;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.packet.PreLoginPacket;
+import org.slf4j.Logger;
 
 import java.net.ConnectException;
 import java.net.UnknownHostException;
@@ -12,13 +14,14 @@ import java.net.UnknownHostException;
 //            GuiScreen, ThreadConnectToServer, ClientPacketHandler, StringTranslate,
 //            GuiButton, GuiMainMenu
 
-public class GuiConnecting extends GuiScreen
+public class ConnectingScreen extends Screen
 {
-
-    public GuiConnecting(Minecraft minecraft, String hostName, int port)
+    private static final Logger LOGGER = LogUtils.getLogger();
+    public ConnectingScreen(Minecraft minecraft, String hostName, int port)
     {
+        mc = minecraft;
         cancelled = false;
-        System.out.println("Connecting to " + hostName + ", " + port);
+        LOGGER.info("Connecting to {}, {}", hostName, port);
         minecraft.changeWorld(null);
         new Thread(() -> {
             try
@@ -36,7 +39,7 @@ public class GuiConnecting extends GuiScreen
                 {
                     return;
                 }
-                mc.displayGuiScreen(new GuiConnectFailed("connect.failed", "disconnect.genericReason", new Object[] {
+                mc.displayScreen(new ConnectFailedScreen("connect.failed", "disconnect.genericReason", new Object[] {
                     "Unknown host '" + hostName + "'"
                 }));
             }
@@ -46,7 +49,7 @@ public class GuiConnecting extends GuiScreen
                 {
                     return;
                 }
-                mc.displayGuiScreen(new GuiConnectFailed("connect.failed", "disconnect.genericReason", new Object[] {
+                mc.displayScreen(new ConnectFailedScreen("connect.failed", "disconnect.genericReason", new Object[] {
                     connectexception.getMessage()
                 }));
             }
@@ -56,8 +59,8 @@ public class GuiConnecting extends GuiScreen
                 {
                     return;
                 }
-                exception.printStackTrace();
-                mc.displayGuiScreen(new GuiConnectFailed("connect.failed", "disconnect.genericReason", new Object[] {
+                LOGGER.error("Unexpected Exception when trying to join server!", exception);
+                mc.displayScreen(new ConnectFailedScreen("connect.failed", "disconnect.genericReason", new Object[] {
                     exception.toString()
                 }));
             }
@@ -75,7 +78,7 @@ public class GuiConnecting extends GuiScreen
     }
 
     @Override
-	public void keyTyped(char c, int i, int mouseX, int mouseY)
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
     }
 
@@ -83,12 +86,12 @@ public class GuiConnecting extends GuiScreen
 	public void init()
     {
         I18n stringtranslate = I18n.getInstance();
-        controlList.clear();
-        controlList.add(new GuiButton(0, width / 2 - 100, height / 4 + 120 + 12, stringtranslate.translateKey("gui.connecting.button.cancel")));
+        buttons.clear();
+        buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 120 + 12, stringtranslate.translateKey("gui.connecting.button.cancel")));
     }
 
     @Override
-	protected void buttonPressed(GuiButton button)
+	protected void buttonClicked(ButtonElement button)
     {
         if(button.id == 0)
         {
@@ -97,25 +100,25 @@ public class GuiConnecting extends GuiScreen
             {
                 clientHandler.disconnect();
             }
-            mc.displayGuiScreen(new GuiSelectServer(new GuiMainMenu()));
+            mc.displayScreen(new SelectServerScreen(new MainMenuScreen()));
         }
     }
 
     @Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick)
+	public void render(int xm, int ym, float partialTick)
     {
-        drawDefaultBackground();
+        renderBackground();
         I18n stringtranslate = I18n.getInstance();
         if(clientHandler == null)
         {
-            drawStringCentered(fontRenderer, stringtranslate.translateKey("gui.connecting.label.connecting"), width / 2, height / 2 - 50, 0xffffff);
-            drawStringCentered(fontRenderer, "", width / 2, height / 2 - 10, 0xffffff);
+            drawStringCentered(font, stringtranslate.translateKey("gui.connecting.label.connecting"), width / 2, height / 2 - 50, 0xffffff);
+            drawStringCentered(font, "", width / 2, height / 2 - 10, 0xffffff);
         } else
         {
-            drawStringCentered(fontRenderer, stringtranslate.translateKey("gui.connecting.label.logging_in"), width / 2, height / 2 - 50, 0xffffff);
-            drawStringCentered(fontRenderer, clientHandler.message, width / 2, height / 2 - 10, 0xffffff);
+            drawStringCentered(font, stringtranslate.translateKey("gui.connecting.label.logging_in"), width / 2, height / 2 - 50, 0xffffff);
+            drawStringCentered(font, clientHandler.message, width / 2, height / 2 - 10, 0xffffff);
         }
-        super.drawScreen(mouseX, mouseY, partialTick);
+        super.render(xm, ym, partialTick);
     }
 
     private ClientPacketHandler clientHandler;
diff --git a/src/main/java/net/minecraft/client/gui/ControllerGlyphRenderer.java b/src/main/java/net/minecraft/client/gui/ControllerGlyphElement.java
similarity index 92%
rename from src/main/java/net/minecraft/client/gui/ControllerGlyphRenderer.java
rename to src/main/java/net/minecraft/client/gui/ControllerGlyphElement.java
index a6f630e3d..636f9046e 100644
--- a/src/main/java/net/minecraft/client/gui/ControllerGlyphRenderer.java
+++ b/src/main/java/net/minecraft/client/gui/ControllerGlyphElement.java
@@ -4,10 +4,10 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.input.controller.Button;
 import net.minecraft.client.input.controller.ControllerInput;
 
-public class ControllerGlyphRenderer extends Gui {
+public class ControllerGlyphElement extends Gui {
     private final Minecraft minecraft;
 
-    public ControllerGlyphRenderer(Minecraft minecraft) {
+    public ControllerGlyphElement(Minecraft minecraft) {
         this.minecraft = minecraft;
     }
 
@@ -22,7 +22,7 @@ public class ControllerGlyphRenderer extends Gui {
         }
 
 
-        minecraft.renderEngine.loadTexture("/assets/minecraft/textures/gui/controller/" + controller.getType().getAssetName() + ".png").bind();
+        minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/controller/" + controller.getType().getAssetName() + ".png").bind();
 
         drawTexturedModalRect(x, y, u, v + vOffset, sizeU, sizeV);
     }
@@ -33,7 +33,7 @@ public class ControllerGlyphRenderer extends Gui {
         int sizeU = 46;
         int sizeV = 46;
 
-        minecraft.renderEngine.loadTexture("/assets/minecraft/textures/gui/controller/" + controllerInput.getType().getAssetName() + ".png").bind();
+        minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/controller/" + controllerInput.getType().getAssetName() + ".png").bind();
 
         drawTexturedModalRect(x, y, u, v, sizeU, sizeV);
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiControllerSetup.java b/src/main/java/net/minecraft/client/gui/ControllerSetupScreen.java
similarity index 87%
rename from src/main/java/net/minecraft/client/gui/GuiControllerSetup.java
rename to src/main/java/net/minecraft/client/gui/ControllerSetupScreen.java
index 0f0b320b0..23279b1f1 100644
--- a/src/main/java/net/minecraft/client/gui/GuiControllerSetup.java
+++ b/src/main/java/net/minecraft/client/gui/ControllerSetupScreen.java
@@ -12,28 +12,28 @@ import java.util.Arrays;
 
 import static org.lwjgl.opengl.GL11.*;
 
-public class GuiControllerSetup extends GuiScreen {
+public class ControllerSetupScreen extends Screen {
     private ControllerInput lastController = null;
-    private GuiButton controllerButton;
-    private ControllerGlyphRenderer glyphRenderer;
+    private ButtonElement controllerButton;
+    private ControllerGlyphElement glyphRenderer;
 
-    public GuiControllerSetup(GuiScreen parentScreen) {
+    public ControllerSetupScreen(Screen parentScreen) {
         super(parentScreen);
     }
 
     @Override
     public void init() {
-        controllerButton = new GuiButton(0, 0, 0, "");
+        controllerButton = new ButtonElement(0, 0, 0, "");
         controllerButton.xPosition = width / 2 - 100;
         controllerButton.yPosition = 16;
         controllerButton.width = 200;
         controllerButton.height = 20;
 
-        controlList.add(controllerButton);
+        buttons.add(controllerButton);
 
-        controlList.add(new GuiButton(-1, width / 2 - 100, height - 40, I18n.getInstance().translateKey("gui.controller_setup.button.back")).setListener((e) -> mc.displayGuiScreen(parentScreen)));
+        buttons.add(new ButtonElement(-1, width / 2 - 100, height - 40, I18n.getInstance().translateKey("gui.controller_setup.button.back")).setListener((e) -> mc.displayScreen(parentScreen)));
 
-        this.glyphRenderer = new ControllerGlyphRenderer(mc);
+        this.glyphRenderer = new ControllerGlyphElement(mc);
 
         updateDisplay();
     }
@@ -48,9 +48,9 @@ public class GuiControllerSetup extends GuiScreen {
     }
 
     @Override
-    public void drawScreen(int mouseX, int mouseY, float partialTick) {
-        drawDefaultBackground();
-        super.drawScreen(mouseX, mouseY, partialTick);
+    public void render(int xm, int ym, float partialTick) {
+        renderBackground();
+        super.render(xm, ym, partialTick);
 
         ControllerInput controller = mc.controllerInput;
 
@@ -71,7 +71,7 @@ public class GuiControllerSetup extends GuiScreen {
             drawJoystick(controller.joyRight, x1 - 48 + 64, y + 96);
 
             GL11.glEnable(GL_TEXTURE_2D);
-            fontRenderer.drawCenteredString("(" + controller.getType().getPrintableName() + ")", width / 2, 40, 0xFFFFFF);
+            font.drawCenteredString("(" + controller.getType().getPrintableName() + ")", width / 2, 40, 0xFFFFFF);
 
             int w = glyphRenderer.getButtonSizeU(controller, controller.buttonLeftTrigger);
             glyphRenderer.drawButton(controller, controller.buttonLeftTrigger, x1 - 65 - w, y, controller.buttonLeftTrigger.isPressed());
@@ -106,7 +106,7 @@ public class GuiControllerSetup extends GuiScreen {
     }
 
     @Override
-    public void keyTyped(char c, int i, int mouseX, int mouseY) {
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
 
     }
 
@@ -132,8 +132,8 @@ public class GuiControllerSetup extends GuiScreen {
     }
 
     @Override
-    protected void buttonPressed(GuiButton button) {
-        super.buttonPressed(button);
+    protected void buttonClicked(ButtonElement button) {
+        super.buttonClicked(button);
 
         if (button.id == 0) {
             int index;
@@ -162,7 +162,7 @@ public class GuiControllerSetup extends GuiScreen {
     }
 
     @Override
-    public void onClosed() {
+    public void removed() {
         if (mc.inputType == InputType.CONTROLLER) {
             mc.mouseInput.grabCursor();
         }
diff --git a/src/main/java/net/minecraft/client/gui/GuiCreateWorld.java b/src/main/java/net/minecraft/client/gui/CreateWorldScreen.java
similarity index 75%
rename from src/main/java/net/minecraft/client/gui/GuiCreateWorld.java
rename to src/main/java/net/minecraft/client/gui/CreateWorldScreen.java
index d247c645f..c7247209f 100644
--- a/src/main/java/net/minecraft/client/gui/GuiCreateWorld.java
+++ b/src/main/java/net/minecraft/client/gui/CreateWorldScreen.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.gui.popup.GuiPopup;
+import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.player.controller.PlayerControllerSP;
 import net.minecraft.core.data.registry.Registries;
@@ -18,19 +18,19 @@ import org.lwjgl.input.Keyboard;
 import java.util.List;
 import java.util.Random;
 
-public class GuiCreateWorld extends GuiScreen {
+public class CreateWorldScreen extends Screen {
     private int overrideSpawnX;
     private int overrideSpawnY;
     private int overrideSpawnZ;
-    private GuiScreen textField;
-    private GuiTextField textboxWorldName;
-    private GuiTextField textboxSeed;
-    private GuiButton createWorldButton;
-    private GuiButton gamemodeButton;
-    private GuiButton cheatsButton;
-    private GuiButton worldTypeButton;
-    private GuiButton buttonRandomWorldName;
-    private GuiButton buttonRandomSeed;
+    private Screen textField;
+    private TextFieldElement textboxWorldName;
+    private TextFieldElement textboxSeed;
+    private ButtonElement createWorldButton;
+    private ButtonElement gamemodeButton;
+    private ButtonElement cheatsButton;
+    private ButtonElement worldTypeButton;
+    private ButtonElement buttonRandomWorldName;
+    private ButtonElement buttonRandomSeed;
     private String folderName;
     private boolean createClicked;
     private Gamemode selectedGamemode = Gamemode.survival;
@@ -38,7 +38,7 @@ public class GuiCreateWorld extends GuiScreen {
     private WorldTypeGroups.Group worldTypeGroup = WorldTypeGroups.DEFAULT;
     private long seed = (new Random()).nextLong();
 
-    public GuiCreateWorld(GuiScreen guiscreen) {
+    public CreateWorldScreen(Screen guiscreen) {
         textField = guiscreen;
     }
 
@@ -52,21 +52,21 @@ public class GuiCreateWorld extends GuiScreen {
     public void init() {
         I18n i18n = I18n.getInstance();
         Keyboard.enableRepeatEvents(true);
-        controlList.clear();
-        controlList.add(createWorldButton = new GuiButton(0, width / 2 - 100, height / 4 + 104 + 12,
+        buttons.clear();
+        buttons.add(createWorldButton = new ButtonElement(0, width / 2 - 100, height / 4 + 104 + 12,
             i18n.translateKey("gui.create_world.button.create_new_world")));
-        controlList.add(new GuiButton(1, width / 2 - 100, height / 4 + 128 + 12,
+        buttons.add(new ButtonElement(1, width / 2 - 100, height / 4 + 128 + 12,
             i18n.translateKey("gui.create_world.button.cancel")));
-        textboxWorldName = new GuiTextField(this, fontRenderer, width / 2 - 100, 60, 200 - 24, 20,
+        textboxWorldName = new TextFieldElement(this, font, width / 2 - 100, 60, 200 - 24, 20,
             "", i18n.translateKey("gui.create_world.label.new_world"));
         textboxWorldName.setMaxStringLength(32);
-        textboxSeed = new GuiTextField(this, fontRenderer, width / 2 - 100, 100, 200 - 24, 20, "", Long.toString(seed));
-        controlList.add(gamemodeButton = new GuiButton(2, width / 2 - 100, 100 + 20 + 4, 98, 20, ""));
-        controlList.add(cheatsButton = new GuiButton(3, width / 2 - 100 + 102, 100 + 20 + 4, 98, 20, ""));
-        controlList.add(worldTypeButton = new GuiButton(4, width / 2 - 100, 100 + 20 + 20 + 4 + 4, ""));
-        controlList.add(buttonRandomWorldName = new GuiButton(5, width / 2 + 100 - 20, 60, 20, 20, "")
+        textboxSeed = new TextFieldElement(this, font, width / 2 - 100, 100, 200 - 24, 20, "", Long.toString(seed));
+        buttons.add(gamemodeButton = new ButtonElement(2, width / 2 - 100, 100 + 20 + 4, 98, 20, ""));
+        buttons.add(cheatsButton = new ButtonElement(3, width / 2 - 100 + 102, 100 + 20 + 4, 98, 20, ""));
+        buttons.add(worldTypeButton = new ButtonElement(4, width / 2 - 100, 100 + 20 + 20 + 4 + 4, ""));
+        buttons.add(buttonRandomWorldName = new ButtonElement(5, width / 2 + 100 - 20, 60, 20, 20, "")
             .setTextures("minecraft:gui/misc/button_random", "minecraft:gui/misc/button_random_highlighted", "minecraft:gui/misc/button_random"));
-        controlList.add(buttonRandomSeed = new GuiButton(6, width / 2 + 100 - 20, 100, 20, 20, "")
+        buttons.add(buttonRandomSeed = new ButtonElement(6, width / 2 + 100 - 20, 100, 20, 20, "")
             .setTextures("minecraft:gui/misc/button_random", "minecraft:gui/misc/button_random_highlighted", "minecraft:gui/misc/button_random"));
         updateButtons();
         updateFolderName();
@@ -95,19 +95,19 @@ public class GuiCreateWorld extends GuiScreen {
     }
 
     @Override
-    public void onClosed() {
+    public void removed() {
         Keyboard.enableRepeatEvents(false);
     }
 
     @Override
-    protected void buttonPressed(GuiButton button) {
+    protected void buttonClicked(ButtonElement button) {
         if (!button.enabled) {
             return;
         }
         if (button.id == 1) {
-            mc.displayGuiScreen(textField);
+            mc.displayScreen(textField);
         } else if (button.id == 0) {
-            mc.displayGuiScreen(null);
+            mc.displayScreen(null);
             if (createClicked) {
                 return;
             }
@@ -136,7 +136,7 @@ public class GuiCreateWorld extends GuiScreen {
             }
             if (mc.worldPresetName != null) mc.thePlayer.setPos(overrideSpawnX, overrideSpawnY, overrideSpawnZ);
             mc.theWorld.getLevelData().setCheatsEnabled(cheatsEnabled);
-            mc.displayGuiScreen(null);
+            mc.displayScreen(null);
         } else if (button == gamemodeButton) {
             I18n i18n = I18n.getInstance();
             List<Gamemode> gamemodeList = Gamemode.getPublicGamemodes();
@@ -157,7 +157,7 @@ public class GuiCreateWorld extends GuiScreen {
                     TextFormatting.GRAY + Registries.WORLD_TYPES.getKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.overworld));
             }
 
-            GuiPopup popup = new PopupBuilder(this, 150)
+            PopupScreen popup = new PopupBuilder(this, 150)
                 .closeOnEsc(0)
                 .closeOnClickOut(0)
                 .withLabel("gui.create_world.label.select_world_type")
@@ -169,7 +169,7 @@ public class GuiCreateWorld extends GuiScreen {
                     }
                 })
                 .build();
-            mc.displayGuiScreen(popup);
+            mc.displayScreen(popup);
         } else if (button == buttonRandomWorldName) {
             textboxWorldName.setText(I18n.getInstance().getCurrentLanguage().getRandomWorldName());
             updateFolderName();
@@ -188,36 +188,36 @@ public class GuiCreateWorld extends GuiScreen {
     }
 
     @Override
-    public void keyTyped(char c, int i, int mouseX, int mouseY) {
-        if (i != Keyboard.KEY_BACK) super.keyTyped(c, i, mouseX, mouseY);
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        if (eventKey != Keyboard.KEY_BACK) super.keyPressed(eventCharacter, eventKey, mx, my);
         if (textboxWorldName.isFocused) {
-            textboxWorldName.textboxKeyTyped(c, i);
+            textboxWorldName.textboxKeyTyped(eventCharacter, eventKey);
         } else if (textboxSeed.isFocused) {
-            textboxSeed.textboxKeyTyped(c, i);
+            textboxSeed.textboxKeyTyped(eventCharacter, eventKey);
         }
-        if (c == '\r') {
-            buttonPressed(controlList.get(0));
+        if (eventCharacter == '\r') {
+            buttonClicked(buttons.get(0));
         }
         updateFolderName();
     }
 
     @Override
-    public void mouseClicked(int mouseX, int mouseY, int mouseButton) {
-        super.mouseClicked(mouseX, mouseY, mouseButton);
-        textboxWorldName.mouseClicked(mouseX, mouseY, mouseButton);
-        textboxSeed.mouseClicked(mouseX, mouseY, mouseButton);
+    public void mouseClicked(int mx, int my, int buttonNum) {
+        super.mouseClicked(mx, my, buttonNum);
+        textboxWorldName.mouseClicked(mx, my, buttonNum);
+        textboxSeed.mouseClicked(mx, my, buttonNum);
     }
 
     @Override
-    public void drawScreen(int mouseX, int mouseY, float partialTick) {
+    public void render(int xm, int ym, float partialTick) {
         I18n stringtranslate = I18n.getInstance();
-        drawDefaultBackground();
-        drawStringCentered(fontRenderer, stringtranslate.translateKey("gui.create_world.label.title"), width / 2, 20, 0xffffff);
-        drawString(fontRenderer, stringtranslate.translateKey("gui.create_world.label.world_name"), width / 2 - 100, 47, 0xa0a0a0);
-        drawString(fontRenderer, stringtranslate.translateKey("gui.create_world.label.seed"), width / 2 - 100, 88, 0xa0a0a0);
+        renderBackground();
+        drawStringCentered(font, stringtranslate.translateKey("gui.create_world.label.title"), width / 2, 20, 0xffffff);
+        drawString(font, stringtranslate.translateKey("gui.create_world.label.world_name"), width / 2 - 100, 47, 0xa0a0a0);
+        drawString(font, stringtranslate.translateKey("gui.create_world.label.seed"), width / 2 - 100, 88, 0xa0a0a0);
         textboxWorldName.drawTextBox();
         textboxSeed.drawTextBox();
-        super.drawScreen(mouseX, mouseY, partialTick);
+        super.render(xm, ym, partialTick);
     }
 
     @Override
@@ -239,6 +239,6 @@ public class GuiCreateWorld extends GuiScreen {
         textboxSeed.setText(seed);
         updateFolderName();
         selectedGamemode = Gamemode.creative;
-        buttonPressed(createWorldButton);
+        buttonClicked(createWorldButton);
     }
 }
